package com.cmx.wanhui.activity;

import android.os.Bundle;
import android.webkit.WebResourceError;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import androidx.appcompat.app.AppCompatActivity;

import com.cmx.wanhui.view.BaseLoadingDialog;
import com.lsxiao.apollo.core.Apollo;
import com.lsxiao.apollo.core.contract.ApolloBinder;

public class BaseActivity extends AppCompatActivity {

    private static final String TAG = "BaseActivity";
    private BaseLoadingDialog mBaseLoadingDialog;
    private ApolloBinder mApolloBinder;
      

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mBaseLoadingDialog = new BaseLoadingDialog(this);
        mApolloBinder = Apollo.bind(this);
    }


    public void showDialog() {
        if (!mBaseLoadingDialog.isShowing()) {
            mBaseLoadingDialog.show();
        }
    }


    public void disDialog() {
        if (mBaseLoadingDialog.isShowing()) {
            mBaseLoadingDialog.dismiss();
        }
    }

    public void setWeb(WebView mWebView) {
        mWebView.setWebViewClient(new WebViewClient() {
                                      @Override
                                      public boolean shouldOverrideUrlLoading(WebView view, String url) {
                                          //使用WebView加载显示url
                                          view.loadUrl(url);
                                          //返回true
                                          return true;
                                      }

                                      @Override
                                      public void onPageFinished(WebView view, String url) {
                                          disDialog();
                                      }

                                      @Override
                                      public void onReceivedError(WebView view, WebResourceRequest request, WebResourceError error) {
                                          disDialog();
                                      }
                                  }

        );
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (mApolloBinder != null) {
            mApolloBinder.unbind();
        }
    }
}