package com.cmx.wanhui.retrofit;

import static com.cmx.wanhui.constant.Events.SERVER_URL;

import android.util.Log;

import com.cmx.wanhui.utils.SpUtils;
import com.cmx.wanhui.activity.MyApplication;
import com.google.gson.reflect.TypeToken;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.concurrent.TimeUnit;

import okhttp3.Interceptor;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import okhttp3.ResponseBody;
import okhttp3.logging.HttpLoggingInterceptor;
import retrofit2.Call;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

/**
 * Created by TTLock on 2018/9/5.
 */


public class RetrofitAPIManager {


    public static ApiService provideClientApi() {
        Retrofit retrofit = new Retrofit.Builder().client(genericClient()).baseUrl(SERVER_URL).addConverterFactory(GsonConverterFactory.create()).build();
        return retrofit.create(ApiService.class);
    }

    public static OkHttpClient genericClient() {
        HttpLoggingInterceptor interceptor = new HttpLoggingInterceptor(new HttpLoggingInterceptor.Logger() {
            @Override
            public void log(String message) {
                //                try {
                //                    String text = URLDecoder.decode(message, "utf-8");
                //                    Log.e("OKHttp-----", text);
                //                } catch (UnsupportedEncodingException e) {
                //                    e.printStackTrace();
                Log.e("OKHttp-----", message);
                //                }
            }
        });
        interceptor.setLevel(HttpLoggingInterceptor.Level.BODY);
        OkHttpClient httpClient = new OkHttpClient.Builder().connectTimeout(35, TimeUnit.SECONDS).readTimeout(35, TimeUnit.SECONDS).writeTimeout(35, TimeUnit.SECONDS).addInterceptor(interceptor).addInterceptor(new Interceptor() {
            @Override
            public Response intercept(Chain chain) throws IOException {
                Request original = chain.request();
                Request.Builder requestBuilder = original.newBuilder().header("token", SpUtils.getString(MyApplication.getmInstance(), "token"));
                Request request = requestBuilder.build();
                return chain.proceed(request);
            }
        }).build();

        return httpClient;
    }

    public static <T> ApiRequtest enqueue(Call<ResponseBody> call, TypeToken<T> resultType, ApiResponse.Listener<ApiResult<T>> listener, ApiResponse.ErrorListener errorListener) {
        ApiRequtest<T> request = new ApiRequtest<>(call, resultType, listener, errorListener);
        return request;
    }
}