package com.cmx.wanhui.ui;

import static com.cmx.wanhui.constant.Events.SERVER_URL;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.ValueCallback;
import android.webkit.WebResourceError;
import android.webkit.WebResourceRequest;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import com.cmx.wanhui.constant.Events;
import com.cmx.wanhui.databinding.FragmentNotificationsBinding;
import com.cmx.wanhui.utils.AndroidtoJs;
import com.cmx.wanhui.utils.L;
import com.cmx.wanhui.utils.MyUtils;
import com.cmx.wanhui.view.BaseLoadingDialog;
import com.lsxiao.apollo.core.Apollo;
import com.lsxiao.apollo.core.annotations.Receive;
import com.lsxiao.apollo.core.contract.ApolloBinder;

public class PersonalFragment extends Fragment {

    private FragmentNotificationsBinding binding;
    private BaseLoadingDialog mBaseLoadingDialog;
    private WebView mWebView;
    private ApolloBinder mApolloBinder;

    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        binding = FragmentNotificationsBinding.inflate(inflater, container, false);
        mBaseLoadingDialog = new BaseLoadingDialog(getActivity());
        View root = binding.getRoot();
        mApolloBinder = Apollo.bind(this);
        MyUtils.setFullscreen(requireActivity(), false, false);
        MyUtils.setAndroidNativeLightStatusBar(requireActivity(), true);
        mWebView = binding.wvMine;
        WebSettings webSettings = mWebView.getSettings();
        webSettings.setJavaScriptEnabled(true);
        webSettings.setCacheMode(WebSettings.LOAD_CACHE_ELSE_NETWORK);
        webSettings.setDomStorageEnabled(true);
        mWebView.addJavascriptInterface(new AndroidtoJs(), "AndroidtoJs");
        //        mWebView.loadUrl(SERVER_URL + "/nigeria/?lang=English#/my");
        mWebView.loadUrl("https://www.baidu.com/");
        showDialog();
        mWebView.setWebViewClient(new WebViewClient() {
                                      @Override
                                      public boolean shouldOverrideUrlLoading(WebView view, String url) {
                                          //使用WebView加载显示url
                                          view.loadUrl(url);
                                          //返回true
                                          return true;
                                      }

                                      @Override
                                      public void onPageFinished(WebView view, String url) {
                                          disDialog();
                                      }

                                      @Override
                                      public void onReceivedError(WebView view, WebResourceRequest request, WebResourceError error) {
                                          disDialog();
                                      }
                                  }

        );
        return root;
    }


    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
        if (mApolloBinder != null) {
            mApolloBinder.unbind();
        }
    }

    public void showDialog() {
        mBaseLoadingDialog = new BaseLoadingDialog(getActivity());
        if (!mBaseLoadingDialog.isShowing()) {
            mBaseLoadingDialog.show();
        }
    }


    public void disDialog() {
        if (mBaseLoadingDialog.isShowing()) {
            mBaseLoadingDialog.dismiss();
        }
    }

    /**
     * 二维码扫描返回
     */
    @Receive(Events.JS_OPEN_SCANQR_BACK)
    public void onQRBack(String msg) {
        String jsString = "javascript:onQRBack(" + msg + ")";
        L.e("JS二维码扫描返回>>>>", jsString);
        mWebView.evaluateJavascript(jsString, new ValueCallback<String>() {
            @Override
            public void onReceiveValue(String s) {
            }
        });
    }

}