package com.cmx.wanhui.utils;

import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.util.Log;
import android.webkit.JavascriptInterface;

import com.cmx.wanhui.constant.Events;
import com.cmx.wanhui.activity.MyApplication;
import com.lsxiao.apollo.core.Apollo;

public class AndroidtoJs {
    private static final String TAG = "cmx_AndroidtoJs";

    // 定义JS需要调用的方法
    // 被JS调用的方法必须加入@JavascriptInterface注解
    @JavascriptInterface
    public String getAppToken() {
        L.e("JS--", "getAppToken()");
        return SpUtils.getString(MyApplication.getmInstance(), "token");
    }

    /**
     * 用户角色类型
     *
     * @return
     */
    @JavascriptInterface
    public String getUser() {
        L.e("JS--", "getUser()");
        return SpUtils.getString(MyApplication.getmInstance(), "admin");
    }


    @JavascriptInterface
    public String getAppVersion() {
        L.e("JS--", "getAppVersion()");
        String versionname;//版本号
        try {
            PackageManager pm = MyApplication.getmInstance().getApplicationContext().getPackageManager();
            PackageInfo pi = pm.getPackageInfo(MyApplication.getmInstance().getApplicationContext().getPackageName(), 0);
            versionname = "V" + pi.versionName;
        } catch (PackageManager.NameNotFoundException e) {
            versionname = "未知";
        }
        Log.e(TAG, "getAppVersion=" + versionname);
        return versionname;
    }

    @JavascriptInterface
    public void existApp() {
        L.e("JS--", "existApp()");
        Apollo.emit(Events.JS_OPEN_LOGOUT);
    }

    @JavascriptInterface
    public void showTab() {//tabbar显示
        L.e("JS--", "showTab()");
        Apollo.emit(Events.JS_OPEN_TABBAR_SHOW);
    }

    @JavascriptInterface
    public void hideTab() {//tabbar隐藏
        L.e("JS--", "hideTab()");
        Apollo.emit(Events.JS_OPEN_TABBAR_HIDE);
    }


    @JavascriptInterface
    public void openWeb(String url) {//打开一个新的web界面
        L.e("JS--", "openWeb()" + url);
        Apollo.emit(Events.JS_OPEN_OPEN_WEB, url);
    }


    @JavascriptInterface
    public void closeWeb() {//关闭那个新的web界面
        L.e("JS--", "closeWeb()");
        Apollo.emit(Events.JS_OPEN_CLOSE_WEB);
    }


    @JavascriptInterface
    public void checkTab(String mode) {//关闭注册/忘记密码
        L.e("JS--", "checkTab()");
        Apollo.emit(Events.JS_OPEN_TAB, mode);
    }

    @JavascriptInterface
    public void scanQR() {//扫描二维码
        L.e("JS--", "scanQR()");
        Apollo.emit(Events.JS_OPEN_SCANQR);
    }

}